/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables.pojos


import cc.cinnamon.canary.users.model.tables.interfaces.IRoles

import javax.annotation.Generated
import javax.validation.constraints.NotNull
import javax.validation.constraints.Size


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
class Roles : IRoles {

    override var id: Long? = null
    @get:NotNull
    @get:Size(max = 10)
    override var name: String? = null
    override var description: String? = null

    constructor() {}

    constructor(value: Roles) {
        this.id = value.id
        this.name = value.name
        this.description = value.description
    }

    constructor(
            id: Long?,
            name: String,
            description: String
    ) {
        this.id = id
        this.name = name
        this.description = description
    }

    override fun equals(obj: Any?): Boolean {
        if (this === obj)
            return true
        if (obj == null)
            return false
        if (javaClass != obj.javaClass)
            return false
        val other = obj as Roles?
        if (id == null) {
            if (other!!.id != null)
                return false
        } else if (id != other!!.id)
            return false
        if (name == null) {
            if (other.name != null)
                return false
        } else if (name != other.name)
            return false
        if (description == null) {
            if (other.description != null)
                return false
        } else if (description != other.description)
            return false
        return true
    }

    override fun hashCode(): Int {
        val prime = 31
        var result = 1
        result = prime * result + if (id == null) 0 else id!!.hashCode()
        result = prime * result + if (name == null) 0 else name!!.hashCode()
        result = prime * result + if (description == null) 0 else description!!.hashCode()
        return result
    }

    override fun toString(): String {
        val sb = StringBuilder("Roles (")

        sb.append(id)
        sb.append(", ").append(name)
        sb.append(", ").append(description)

        sb.append(")")
        return sb.toString()
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    override fun from(from: IRoles) {
        id = from.id
        name = from.name
        description = from.description
    }

    /**
     * {@inheritDoc}
     */
    override fun <E : IRoles> into(into: E): E {
        into.from(this)
        return into
    }

    companion object {

        private val serialVersionUID: Long = -769909938
    }
}
